package event

import (
	"context"

	"go.ipao.vip/atom"
	"go.ipao.vip/atom/container"
	"go.ipao.vip/atom/contracts"
	"quyun/v2/app/commands"
	"quyun/v2/app/events/subscribers"
	"quyun/v2/providers/app"
	"quyun/v2/providers/event"
	"quyun/v2/providers/postgres"

	log "github.com/sirupsen/logrus"
	"github.com/spf13/cobra"
	"go.uber.org/dig"
)

func defaultProviders() container.Providers {
	return commands.Default(container.Providers{
		postgres.DefaultProvider(),
	}...)
}

func Command() atom.Option {
	return atom.Command(
		atom.Name("event"),
		atom.Short("start event processor"),
		atom.RunE(Serve),
		atom.Providers(
			defaultProviders().
				With(
					subscribers.Provide,
				),
		),
	)
}

type Service struct {
	dig.In

	App      *app.Config
	PubSub   *event.PubSub
	Initials []contracts.Initial `group:"initials"`
}

func Serve(cmd *cobra.Command, args []string) error {
	return container.Container.Invoke(func(ctx context.Context, svc Service) error {
		log.SetFormatter(&log.JSONFormatter{})

		if svc.App.IsDevMode() {
			log.SetLevel(log.DebugLevel)
		}

		return svc.PubSub.Serve(ctx)
	})
}
